Summary:	GitLab ssh access and repository management
Name:		gitlab-shell
Version:	4.1.1
Release:	1
License:	MIT
Group:		Applications/Shells
Source0:	https://gitlab.com/gitlab-org/gitlab-shell/repository/archive.tar.bz2?ref=v%{version}&/%{name}-%{version}.tar.bz2
# Source0-md5:	401549acd04258f400a6fb1821525911
Patch0:		unvendor-redis.patch
Patch1:		skip_hooks_setup.patch
Patch2:		config.yml.patch
URL:		https://gitlab.com/gitlab-org/gitlab-shell
BuildRequires:	rpm-rubyprov
BuildRequires:	rpmbuild(macros) >= 1.665
BuildRequires:	sed >= 4.0
Requires:	git-core >= 2.7.3
Requires:	gitlab-common >= 8.12
Requires:	rsync
Requires:	ruby >= 1:2.0
Requires:	ruby-redis >= 3.3.0
Suggests:	redis-server
Conflicts:	gitlab-ce < 8.7.5-0.17
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
GitLab Shell is an application that allows you to execute git commands
and provide ssh access to git repositories. It is not a Unix shell nor
a replacement for Bash or Zsh.

%prep
%setup -qc
mv %{name}-*/* .
%patch0 -p1
%patch1 -p1
cp -p config.yml.example config.yml
%patch2 -p1

%{__sed} -i -e '1 s,#!.*ruby,#!%{__ruby},' bin/* hooks/*

mv lib/vendor .

# add hook dirs
# https://gitlab.com/gitlab-org/gitlab-shell/merge_requests/93
install -d hooks/{post-receive,pre-receive,update}.d

# deprecated
rm support/rewrite-hooks.sh
# stupid script, rather not package it at all
rm support/truncate_repositories.sh*

# cleanup backups after patching
find '(' -name '*~' -o -name '*.orig' ')' -print0 | xargs -0 -r -l512 rm -f

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -a VERSION *.yml bin lib hooks support $RPM_BUILD_ROOT%{_datadir}/%{name}

install -d $RPM_BUILD_ROOT%{_sysconfdir}/gitlab
mv $RPM_BUILD_ROOT%{_datadir}/gitlab-shell/config.yml $RPM_BUILD_ROOT%{_sysconfdir}/gitlab/gitlab-shell-config.yml
ln -sf %{_sysconfdir}/gitlab/gitlab-shell-config.yml $RPM_BUILD_ROOT%{_datadir}/gitlab-shell/config.yml

# it will attempt to symlink if it doesn't exist
# /var/lib/gitlab/config/initializers/gitlab_shell_secret_token.rb +18
touch $RPM_BUILD_ROOT%{_sysconfdir}/gitlab/.gitlab_shell_secret
ln -s %{_sysconfdir}/gitlab/.gitlab_shell_secret $RPM_BUILD_ROOT%{_datadir}/%{name}/.gitlab_shell_secret

%clean
rm -rf $RPM_BUILD_ROOT

%post
%banner -o -e %{name} <<EOF

To rebuild authorized_keys file, run:

  # gitlab-rake gitlab:shell:setup

http://docs.gitlab.com/ce/raketasks/maintenance.html#rebuild-authorized_keys-file

EOF

%files
%defattr(644,root,root,755)
%doc README.md CHANGELOG LICENSE
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/gitlab/gitlab-shell-config.yml
%attr(640,git,git) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/gitlab/.gitlab_shell_secret
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/lib
%dir %{_datadir}/%{name}/bin
%attr(755,root,root) %{_datadir}/%{name}/bin/*
%{_datadir}/%{name}/.gitlab_shell_secret
%{_datadir}/%{name}/config.yml
%{_datadir}/%{name}/VERSION

%dir %{_datadir}/%{name}/hooks
%dir %{_datadir}/%{name}/hooks/post-receive.d
%dir %{_datadir}/%{name}/hooks/pre-receive.d
%dir %{_datadir}/%{name}/hooks/update.d
%attr(755,root,root) %{_datadir}/%{name}/hooks/post-receive
%attr(755,root,root) %{_datadir}/%{name}/hooks/pre-receive
%attr(755,root,root) %{_datadir}/%{name}/hooks/update
%changelog
* Fri Dec 23 2016 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/gitlab-shell.git;a=log;h=master

* Fri Dec 23 2016 Elan Ruusamäe <glen@delfi.ee> 2cc3340
- package hooks.d dirs

* Fri Dec 23 2016 Elan Ruusamäe <glen@delfi.ee> 8d514e0
- up to 4.1.1

* Tue Dec 06 2016 Elan Ruusamäe <glen@delfi.ee> b532114
- patch to allow disabling hooks setup

* Tue Dec 06 2016 Elan Ruusamäe <glen@delfi.ee> 42e67b0
- v4.0.0

* Sun Oct 23 2016 Elan Ruusamäe <glen@delfi.ee> 990c70c
- up to 3.6.6

* Fri Sep 30 2016 Elan Ruusamäe <glen@delfi.ee> b17cca9
- v3.6.2

* Fri Sep 30 2016 Elan Ruusamäe <glen@delfi.ee> 8a8aa17
- v3.6.1

* Sun Sep 25 2016 Elan Ruusamäe <glen@delfi.ee> b06003d
- rel 2

* Sun Sep 25 2016 Elan Ruusamäe <glen@delfi.ee> 4ae12a1
- use gitlab-common for user and base dirs

* Fri Sep 23 2016 Elan Ruusamäe <glen@delfi.ee> 2681706
- own gitlab_shell_secret by git user

* Fri Sep 23 2016 Elan Ruusamäe <glen@delfi.ee> 4ba6f8b
- move projects uses rsync

* Fri Sep 23 2016 Elan Ruusamäe <glen@delfi.ee> 485fccd
- really unvendor redis

* Fri Sep 23 2016 Elan Ruusamäe <glen@delfi.ee> 29e6920
- up to 3.6.0, required by gitlab 8.12

* Mon Aug 22 2016 Elan Ruusamäe <glen@delfi.ee> 5d59701
- up to 3.4.0 (Redis Sentinel support for GitLab 8.11)

* Sat Aug 20 2016 Elan Ruusamäe <glen@delfi.ee> b755e73
- up to v3.3.2

* Thu Aug 04 2016 Elan Ruusamäe <glen@delfi.ee> 7f95a39
- up to 3.3.0

* Thu Jun 16 2016 Elan Ruusamäe <glen@delfi.ee> 16fbd2d
- redis server suggest

* Thu Jun 16 2016 Elan Ruusamäe <glen@delfi.ee> df52cff
- up to 3.0.0

* Sun May 15 2016 Elan Ruusamäe <glen@delfi.ee> fff2cd7
- add banner how to rebuild authorized_keys file

* Fri May 13 2016 Elan Ruusamäe <glen@delfi.ee> d56df2c
- use git/git uid

